LINUX.ORG.RU

На сайте «Компьютерры» опубликовано интервью с разработчиком Deepsolver

 ,


0

1

Существующие менеджеры пакетов для Linux часто критикуют за высокую для неопытных пользователей сложность, трудности с разрешением зависимостей между пакетами и тому подобные вещи. О новых подходах к управлению установленными программами задумываются разработчики многих дистрибутивов, и российские компании не исключение. Инженер-программист «Альт Линукс», кандидат технических наук Михаил Пожидаев рассказал «Компьютерре» о Deepsolver — перспективной разработке, которая может заменить в дистрибутивах ALT Linux использующийся сейчас «Advanced Packaging Tool» (APT).

>>> Подробности

★★

Проверено: maxcom ()

«Создайте систему, которой сможет пользоваться дурак, и только дурак захочет ею пользоваться. »

rmammoth ()

Очередной велосипед?

leave ★★★★★ ()
Ответ на: комментарий от punya

мне кажется в новость надо добавить доказательство что разрешение зависимостей np-полная задача

проглядел по диагонали. а что делает установку пакетов NP-полной?

каждый пакет имеет ссылки на требуемые пакеты - идем во все прописанные и берем последнюю подходящую версию. И так далее пока не установим все пакеты. Таким образом устанавливается и обновляется лишь дерево пакетов.

Почему появляется NP-сложность?

VoDA ★★ ()
Ответ на: комментарий от punya

мне кажется в новость надо добавить доказательство что разрешение зависимостей np-полная задача

В тексте сказано об NP-полноте.

«Собственная реализация обработки зависимостей Deepsolver основана на полиномиальном полностью детерминированном алгоритме с наложением некоторых дополнительных ограничений на задачу, которая должна дать гарантированный минимум, подходящий под требования промышленного применения. Последующее добавление приближенных алгоритмов без ограничений на задачу не запрещается, обязательно будем пытаться делать это, чтобы удобство пользователя попутно не страдало. Начнём, скорее всего, с попытки задействования libsolv. Если всё пройдёт удачно - отлично, если же нет - выполним свою реализацию minisat или другого подходящего алгоритма».

tailgunner ★★★★★ ()

Deepsolver предоставляет некоторый *достаточный* и отшлифованный минимальный функционал по умолчанию, но прочие идеи не запрещаются.
Но и сообщество принимает *достаточно* активное участие в обсуждении деталей развития.
В *достаточном* интересе внутри сообщества «ALT Linux» сомневаться не приходится.
Как бы то ни было, *абсолютно* неразумно разрабатывать Deepsolver, предполагая сохранение APT.

Мдя... И это говорит кандидат *технических* наук!

Подобное бессмысленное употребление слов «достаточно» и «абсолютно» характерно для журналюг и спортивных комментаторов, которым всё равно что говорить, лишь бы заполнить пустоту какими-нибудь словами.

И шедевр:

Уже не секрет, что точная обработка запроса пользователя на установку или удаление программы в нынешнем Linux - это NP-полная задача, то есть в точной постановке с гарантированным ответом нерешаемая.

Может быть, он и имел в виду что-то паравильное, но выдал на-гора какую-то хню. Или журнализд так записал.

anonymous ()
Ответ на: комментарий от VoDA

пакет может зависеть не от фиксированной версии «от версии до версии» или просто «от версии». типа берут к уже установленному множеству пакетов присобачивают пакет начинают проверять зависимости и выковыривать конфликты

punya ★★ ()
Ответ на: комментарий от punya

Не надо. Надо добавить доказательство того, что

точная обработка запроса пользователя на установку или удаление программы в нынешнем Linux ... задача ... в точной постановке с гарантированным ответом нерешаемая.

А то кроме конфликтов пакетов ничего «нерешаемого» пока что не видно.

LamerOk ★★★★★ ()

Нисколько не умаляя крутость проекта, хочется отметить недостаточно ясный ответ на простой вопрос: «Чего не хватает в существующей системе, и в чём преимущество Deepsolver над аналогичными решениями?». Я прочитал весь текст, но так и не понял сути. Автор не умеет излагать кратко и понятно?

matumba ★★★★★ ()
Ответ на: комментарий от VoDA

каждый пакет имеет ссылки на требуемые пакеты - идем во все прописанные и берем последнюю подходящую версию.

...которые, в свою очередь, также могут иметь зависимости и т.д.

alex-w ★★★★★ ()

Касательно NP-полноты, как вы догадываетесь, всем пофиг - людям нужна РАБОТАЮЩАЯ СИСТЕМА. Через костыли ли или напильник, но должна быть возможность обновлять любой пакет и с такой же лёгкостью его убирать/ремонтировать систему. Поэтому каким бы научным словом ни назвали очередной вело-менеджер пакетов, главное - чтобы было место напильнику. :) Тем более, в таком спагетти, как линукс.

matumba ★★★★★ ()

заменить «Advanced Packaging Tool» (APT)

Толсто... Я бы заменил вот таких вот «кандидатов» на что-то более полезное. Когда я первый раз попробовал Ubuntu, то ничего сложного в APT не нашел. И это был мой первый Linux. Мифы о том, что пакетные менеджеры сложны для новичков - это бред, причем сродни «Linux - система для программистов!». APT очень простой менеджер, и лично мне все в нем нравится. А изобретать велосипеды нынче в моде, ага.

anonymous ()
Ответ на: комментарий от anonymous

Мифы о том, что пакетные менеджеры сложны для новичков - это бред

Ну почему сразу «бред»? Может это какие-нибудь альтопроблемы..

LamerOk ★★★★★ ()
Ответ на: комментарий от sluggard

Ойвэй, мое ЧСВ прям на глазах раздулось после прочтения твоего комментария :)

leave ★★★★★ ()
Ответ на: комментарий от matumba

Предлагаю срочно перейти на пакетный менеджер PC-BSD.

leave ★★★★★ ()

Поповщина, да и только.

Deleted ()
Ответ на: комментарий от punya

Так я и написал - берут пакет подходящей версии.

пользователь хочет пакет А версии 1.1, он работает с пакетами Б от 1.0 до 1.3. Таким образом ставится пакет А 1.1 и Б последней подходящей версии - 1.3

Пока все просто.

VoDA ★★ ()
Ответ на: комментарий от LamerOk

Почему появляется NP-сложность?

Потому что ничто не ограничивает зависимости.

Ну собственно зависимости ограничены тем, что они не зацикливаются, а являются деревом. Собственно и все.

VoDA ★★ ()
Ответ на: комментарий от alex-w

каждый пакет имеет ссылки на требуемые пакеты - идем во все прописанные и берем последнюю подходящую версию.

...которые, в свою очередь, также могут иметь зависимости и т.д.

От которых дальше берем последнюю подходящую версию. Собственно дерево.

VoDA ★★ ()
Ответ на: комментарий от rmammoth

«Создайте систему, которой сможет пользоваться дурак, и только дурак захочет ею пользоваться. »

Черт, до чего ж в точку! :D

ak372771 ()
Ответ на: комментарий от punya

мне кажется в новость надо добавить доказательство что разрешение зависимостей np-полная задача

Черт, до вашего комментария даже не задумывался об этом... /me посмотрел на *.pom файлы другим взглядом (o_O)...

X-Pilot ★★★★★ ()
Ответ на: комментарий от alex-w

И что? Запускам рекурсивно функцию установки и для этих пакетов. Рано или поздно пакеты кончатся. Получив полный список пакетов для установки ставим их в порядке зависимостей, если это возможно (если пакет A, зависит от пакета B, то B надо попробовать установить раньше). Если есть циклическая зависимость (чего мейнтейнеры должны избегать), то ставим в любом порядке (лучше начать с тех пакетов, который не имеют install-скриптов, потому что они удачно поставятся даже если вообще не ставить зависимости, другое дело, что для работы надо будет довести установку до конца).

Всё зависит исключительно от криворукости мейнтейнеров - если они создали кучу пакетов с циклическими зависимостями, старыми версиями (пакет А уже имеет версию 1.2, но пакет B требует A не выше 1.1 и в репозитории нет обновления).

Хотя некоторые пакетные менеджеры пытаются быть через чур умными и ещё самостоятельно решать конфликты (хотя тут надо максимально просто - пакет A конфликтует с пакетом B? Предложить удалить пакет B и всё что от него зависит, либо отказаться от установки) и сносить пол-системы. За образец лучше взять арчевский pacman.

KivApple ★★★★★ ()
Ответ на: комментарий от anonymous

apt-rpm, который используется в altlinux, отличается от apt использующегося в debian based системах. Сначала сравните функционал, затем выводы будете делать.

anonymous ()

ALT Linux so cool

=)

anonymous ()
Ответ на: комментарий от leave

Из всех читателей новости по ссылке перейдет человек 10, из них поймет написанное двое :)

Чего так критично? :)
ЗЫ: прочёл статейку, еще до публикации тут, если что))

Spirit_of_Stallman ★★★ ()
Ответ на: комментарий от Spirit_of_Stallman

Это что... То ли не перешедшие по ссылке, то ли не понявшие написанное тут еще и на полном серьезе предлагают алгоритмы решения задачи установки пакетов с зависимостями...

anonymous ()

Еще одно подтверждение купленных корочек и полной невозможности сделать из ALT-а нормальную систему. Походу команда сгнила как старый пень. Стыдно за соотечественников, несущих полный бред.

Менеджер пакетов «платформой» будет.. Скорее трамплином в мусорный бак, ибо в точной постановке задача с гарантированным ответом нерешаемая по его разумению. Хотя они наверно на нобелевскую хотят вытянуть. И ведь не боязно так деньги зарабатывать, «гарантированно сливаясь», мягко говоря..

«В ALT Linux сборка пакетов осуществляется в изолированной chroot-среде, обслуживанием которой занимается Hasher».. Мда.. Помню как-то пробовал что-то примитивное скомпилировать в альте, так тут весь лор укатывался от предлагаемых ими костылей и дельных советов.

Я не против их дистрибутива, я против маразма.

glibych ★★ ()
Ответ на: комментарий от VoDA

мне кажется в новость надо добавить доказательство что разрешение зависимостей np-полная задача

Втопку теорию, главное чтоб в реализации решения небыло ошибок!

К сожалению и apt и aptitude и прочие поделия (че там у нас в SuSe?) глючат и впадают в маразм на пустом месте, и ставят в позу всю систему. По закону подлости, эти глюки достаются начинающим пользователям.

Xintrea ★★★★★ ()

Эх, жалко выпилили с http://deepsolver.altlinux.org/ страничку «сравнение». Основным недостатком yum ВНЕЗАПНО был назван python, а libsolv они не хотели использовать из-за того, что решение системы булевых уравнений есть NP-полная задача, откуда был сделан вывод, что решать её вообще не имеет смысла (но мы-то с вами знаем, что на самом деле проблема в окаменелом ALT-rpm).

raorn ()
Ответ на: комментарий от anonymous

Мдя... И это говорит кандидат *технических* наук!

В Роиссе, да и на постсоветщине теперь таких «кандидатов» пруд пруди.

Deleted ()

Основные требования к Deepsolver следующие:

  • Наличие алгоритмов обработки зависимостей между пакетами, позволяющие использовать Deepsolver как на компьютерах пользователей и на серверах, так и для подготовки сборочного окружения пакетов. - ohgod, какая инновация
  • Возможность гибкого расширения функциональности, включая добавление поддержки сторонних библиотек от проектов, решающих близкие задачи. - мы придумали плагины !!11
  • Развитую систему хранения и поиска информации о пакетах. - теперь и на фейсбуке, дропбоксе, гугльдрайве, етц.
spiro ★★ ()

- Почему вы хотите распространять библиотечную часть на условиях LGPL? Предполагается возможность линковки с какими-то проприетарными компонентами?

- Да, дело именно в этом, но просьба о возможности линковки с проприетарными продуктами пришла из сообщества. Каких-либо причин препятствовать этому, кажется, нет, поэтому, скорее всего, поменяем лицензию библиотеки на LGPL. Какие именно продукты и проекты планируют участники сообщества, мы не знаем, но в любом случае готовы поддержать это направление.

Идиоты, что тут поделаешь.

Deleted ()
Ответ на: комментарий от glibych

Помню как-то пробовал что-то примитивное скомпилировать в альте

Можно посмотреть на это примитивное? А то есть подозрение, что ты троль.

Vovka-Korovka ★★★★★ ()
Ответ на: комментарий от anonymous

Подобное бессмысленное употребление слов «достаточно» и «абсолютно» характерно для журналюг

Ну так жарналюга его слова и доносит. У них вообще в порядке вещей переделывать ответы респондента подчистую.

fang ()
Ответ на: комментарий от fang

Ну так жарналюга его слова и доносит. У них вообще в порядке вещей переделывать ответы респондента подчистую.

Смотрю здесь много знатоков специфики работы СМИ. Прямая речь спикера приводится с минимальной литературной правкой и корректурой. Текст данного интервью перед публикацией согласовывался со спикером — это обычная практика.

sabbakka ★★ ()
Ответ на: комментарий от rmammoth

«Создайте систему, которой сможет пользоваться дурак, и только дурак захочет ею пользоваться. »

Гейцоджобсы давно поняли, что это гигантский рынок.

anonymous ()
Ответ на: комментарий от sabbakka

Журнализд детектед!

Смотрю здесь много знатоков специфики работы СМИ

А ты как думал

fang ()
Ответ на: комментарий от Xintrea

К сожалению и apt и aptitude и прочие поделия (че там у нас в SuSe?) глючат и впадают в маразм на пустом месте, и ставят в позу всю систему. По закону подлости, эти глюки достаются начинающим пользователям.

Собственно сижу в уютной Убунточке + держу на серверах. И собственно aptitude работает на отлично. Гораздо меньше косяков, чем в том же Gentoo Portage. Конечно сравнивать бинарный и сорцорый дистры не корректно, но можно сравнить количество глюков при штатном обновлении.

PS в Ubuntu мне удавалось добиться глюков при обновлении на первые альфа-версии еще не отрелизенных версий. Собственно это было ясно изначально поскольку апдейт на альфу это всегда гора багов.

VoDA ★★ ()
Вы не можете добавлять комментарии в эту тему. Тема перемещена в архив.